#include <mainwin.h>

/********************* CONTRIBUTED BY SASWAT PADHI************************
**************************************************************************/    
void MainWin::Initialize()
{
    Init_ASM();
    Init_Indices();
    Init_Values();
    Init_Errors();
    Init_OpCodes();
}

void MainWin::Init_ASM()
{
    Instruction.push_back("CC");
    Instruction.push_back("CM");
    Instruction.push_back("CP");
    Instruction.push_back("CZ");
    Instruction.push_back("JC");
    Instruction.push_back("JM");
    Instruction.push_back("JP");
    Instruction.push_back("RP");
    Instruction.push_back("RM");
    Instruction.push_back("RC");
    Instruction.push_back("POP");
    Instruction.push_back("RET");
    Instruction.push_back("RNZ");
    Instruction.push_back("RNC");
    Instruction.push_back("ACI");
    Instruction.push_back("ADC");
    Instruction.push_back("ADD");
    Instruction.push_back("ADI");
    Instruction.push_back("ANA");
    Instruction.push_back("ANI");
    Instruction.push_back("MOV");
    Instruction.push_back("MVI");
    Instruction.push_back("NOP");
    Instruction.push_back("ORA");
    Instruction.push_back("ORI");
    Instruction.push_back("CMA");
    Instruction.push_back("CMC");
    Instruction.push_back("CMP");
    Instruction.push_back("CNC");
    Instruction.push_back("CNZ");
    Instruction.push_back("CPO");
    Instruction.push_back("CPI");
    Instruction.push_back("CPE");
    Instruction.push_back("XRA");
    Instruction.push_back("XRI");
    Instruction.push_back("DCX");
    Instruction.push_back("JNC");
    Instruction.push_back("JNZ");
    Instruction.push_back("JPE");
    Instruction.push_back("JPO");
    Instruction.push_back("LDA");
    Instruction.push_back("LXI");
    Instruction.push_back("DAD");
    Instruction.push_back("DCR");
    Instruction.push_back("SBI");
    Instruction.push_back("SBB");
    Instruction.push_back("SUI");
    Instruction.push_back("SUB");
    Instruction.push_back("RAL");
    Instruction.push_back("RAR");
    Instruction.push_back("RPO");
    Instruction.push_back("RPE");
    Instruction.push_back("STC");
    Instruction.push_back("JMP");
    Instruction.push_back("RLC");
    Instruction.push_back("HLT");
    Instruction.push_back("RRC");
    Instruction.push_back("XTHL");
    Instruction.push_back("CALL");
    Instruction.push_back("XCHG");
    Instruction.push_back("LDAX");
    Instruction.push_back("LHLD");
    Instruction.push_back("PUSH");
    Instruction.push_back("PCHL");
    sort(Instruction.begin(),Instruction.end());

    /*
     0 = no parameter

     1 = 1 register param
     2 = 1 8-bit param
     3 = 1 16-bit param

     4 = 2 register params
     5 = 1 register, 1 8-bit param
     6 = 1 register, 1 16-bit param
    */

    Parameters["RZ"] = 0;
    Parameters["RM"] = 0;
    Parameters["RC"] = 0;
    Parameters["RP"] = 0;
    Parameters["RET"] = 0;
    Parameters["RNZ"] = 0;
    Parameters["RNC"] = 0;
    Parameters["NOP"] = 0;
    Parameters["CMC"] = 0;
    Parameters["CMA"] = 0;
    Parameters["STC"] = 0;
    Parameters["RPO"] = 0;
    Parameters["RPE"] = 0;
    Parameters["RAL"] = 0;
    Parameters["RAR"] = 0;
    Parameters["HLT"] = 0;
    Parameters["RLC"] = 0;
    Parameters["RRC"] = 0;
    Parameters["XTHL"] = 0;
    Parameters["PCHL"] = 0;
    Parameters["XCHG"] = 0;

    Parameters["JC"] = 3;
    Parameters["JM"] = 3;
    Parameters["JP"] = 3;
    Parameters["CC"] = 1;
    Parameters["CM"] = 3;
    Parameters["CZ"] = 3;
    Parameters["CP"] = 3;
    Parameters["JMP"] = 3;
    Parameters["LDA"] = 3;
    Parameters["JNC"] = 3;
    Parameters["JNZ"] = 3;
    Parameters["JPE"] = 3;
    Parameters["JPO"] = 3;
    Parameters["CPO"] = 3;
    Parameters["CPI"] = 3;
    Parameters["CPE"] = 3;
    Parameters["CNZ"] = 3;
    Parameters["CNC"] = 3;
    Parameters["SUB"] = 2;
    Parameters["SBB"] = 3;
    Parameters["CALL"] = 3;
    Parameters["LHLD"] = 3;

    Parameters["SBI"] = 2;
    Parameters["SUI"] = 2;
    Parameters["XRI"] = 2;
    Parameters["ORI"] = 2;
    Parameters["ADI"] = 2;
    Parameters["ACI"] = 2;
    Parameters["ANI"] = 2;

    Parameters["DAD"] = 1;
    Parameters["DCR"] = 1;
    Parameters["DCX"] = 1;
    Parameters["XRA"] = 1;
    Parameters["CMP"] = 1;
    Parameters["ORA"] = 1;
    Parameters["ANA"] = 1;
    Parameters["ADC"] = 1;
    Parameters["ADD"] = 1;
    Parameters["POP"] = 1;
    Parameters["PUSH"] = 1;
    Parameters["LDAX"] = 1;

    Parameters["LXI"] = 6;
    Parameters["MOV"] = 4;
    Parameters["MVI"] = 5;
}

void MainWin::Init_Indices()
{
    /***************** GLOBAL INDICES OF FLAGS AND REGISTERS ******************
    ***************************************************************************/
    IndexOfFlag["S"] = 0;
    IndexOfFlag["Z"] = 1;
    IndexOfFlag["AC"] = 2;
    IndexOfFlag["P"] = 3;
    IndexOfFlag["CY"] = 4;

    IndexOfRegister["A"] = 0;
    IndexOfRegister["B"] = 1;
    IndexOfRegister["C"] = 2;
    IndexOfRegister["D"] = 3;
    IndexOfRegister["E"] = 4;
    IndexOfRegister["H"] = 5;
    IndexOfRegister["L"] = 6;

    IndexOfRegister["F"] = 7;
    IndexOfRegister["BC"] = 8;
    IndexOfRegister["DE"] = 9;
    IndexOfRegister["HL"] = 10;
    IndexOfRegister["PC"] = 11;
    IndexOfRegister["SP"] = 12;
}

void MainWin::Init_Values()
{
    Register[IndexOfRegister["A"]] = 0;
    Register[IndexOfRegister["B"]] = 0;
    Register[IndexOfRegister["C"]] = 0;
    Register[IndexOfRegister["D"]] = 0;
    Register[IndexOfRegister["E"]] = 0;
    Register[IndexOfRegister["F"]] = 0;
    Register[IndexOfRegister["H"]] = 0;
    Register[IndexOfRegister["L"]] = 0;
    Register[IndexOfRegister["BC"]] = 0;
    Register[IndexOfRegister["DE"]] = 0;
    Register[IndexOfRegister["HL"]] = 0;
    Register[IndexOfRegister["PC"]] = 0;
    Register[IndexOfRegister["SP"]] = 0xFFFE;
    Register[IndexOfRegister["PSW"]] = 0;
    
    Flag[IndexOfFlag["S"]] = 0;
    Flag[IndexOfFlag["Z"]] = 0;
    Flag[IndexOfFlag["CY"]] = 0;
    Flag[IndexOfFlag["AC"]] = 0;
    Flag[IndexOfFlag["P"]] = 0;
    
    OFlag[IndexOfFlag["S"]] = 0;
    OFlag[IndexOfFlag["Z"]] = 0;
    OFlag[IndexOfFlag["CY"]] = 0;
    OFlag[IndexOfFlag["AC"]] = 0;
    OFlag[IndexOfFlag["P"]] = 0;

    Limit["A"] = 256;
    Limit["F"] = 256;
    Limit["B"] = 256;
    Limit["C"] = 256;
    Limit["D"] = 256;
    Limit["E"] = 256;
    Limit["H"] = 256;
    Limit["L"] = 256;
    Limit["BC"] = 65536;
    Limit["DE"] = 65536;
    Limit["HL"] = 65536;
    Limit["PSW"] = 65536;
}

void MainWin::Init_Errors()
{
    ErrorMsgs["ER_00"] = "[S] SYNTAX ERROR : Redundant data after instruction.";
    ErrorMsgs["ER_01"] = "[S] SYNTAX ERROR : Insufficient number of arguments.";
    ErrorMsgs["ER_02"] = "[I] INPUT ERROR : 8-bit hexadecimal value expected.";
    ErrorMsgs["ER_03"] = "[I] INPUT ERROR : Invalid register.";
    ErrorMsgs["ER_04"] = "[S] SYNTAX ERROR : Improper syntax.";
    ErrorMsgs["ER_05"] = "[I] INPUT ERROR : Invalid instruction.";
    ErrorMsgs["ER_06"] = "[I] INPUT ERROR : 16-bit hexadecimal value expected.";
}

/*********************** CONTRIBUTED BY VIPUL SINGH *************************
*****************************************************************************/    
void MainWin::Init_OpCodes()
{
    OpCode[0] = "NOP";
    OpCode[1] = "LXI B";
    OpCode[2] = "STAX";
    OpCode[3] = "INX B";
    OpCode[4] = "INR B";
    OpCode[5] = "DCR B";
    OpCode[6] = "MVI B";
    OpCode[7] = "RLC";
    OpCode[9] = "DAD B";
    OpCode[10] = "LDAX B";
    OpCode[11] = "DCX B";
    OpCode[12] = "INR C";
    OpCode[13] = "DCR C";
    OpCode[14] = "MVI C";
    OpCode[15] = "RRC";
    OpCode[17] = "LXI D";
    OpCode[18] = "STAX D";
    OpCode[19] = "INX D";
    OpCode[20] = "INR D";
    OpCode[21] = "DCR D";
    OpCode[22] = "MVI D";
    OpCode[23] = "RAL";
    OpCode[25] = "DAD D";
    OpCode[26] = "LDAX D";
    OpCode[27] = "DCX D";
    OpCode[28] = "INR E";
    OpCode[29] = "DCR E";
    OpCode[30] = "MVI E";
    OpCode[31] = "RAR";
    OpCode[32] = "RIM";
    OpCode[33] = "LXI H";
    OpCode[34] = "SHLD";
    OpCode[35] = "INX H";
    OpCode[36] = "INR H";
    OpCode[37] = "DCR H";
    OpCode[38] = "MVI H";
    OpCode[39] = "DAA";
    OpCode[41] = "DAD H";
    OpCode[42] = "LHLD";
    OpCode[43] = "DCX H";
    OpCode[44] = "INR L";
    OpCode[45] = "DCR L";
    OpCode[46] = "MVI L";
    OpCode[47] = "CMA";
    OpCode[48] = "SIM";
    OpCode[49] = "LXI SP";
    OpCode[50] = "STA";
    OpCode[51] = "INX SP";
    OpCode[52] = "INR M";
    OpCode[53] = "DCR M";
    OpCode[54] = "MVI M";
    OpCode[55] = "STC";
    OpCode[57] = "DAD SP";
    OpCode[58] = "LDA";
    OpCode[59] = "DCX SP";
    OpCode[60] = "INR A";
    OpCode[61] = "DCR A";
    OpCode[62] = "MVI A";
    OpCode[63] = "CMC";
    OpCode[64] = "MOV B,B";
    OpCode[65] = "MOV B,C";
    OpCode[66] = "MOV B,D";
    OpCode[67] = "MOV B,E";
    OpCode[68] = "MOV B,H";
    OpCode[69] = "MOV B,L";
    OpCode[70] = "MOV B,M";
    OpCode[71] = "MOV B,A";
    OpCode[72] = "MOV C,B";
    OpCode[73] = "MOV C,C";
    OpCode[74] = "MOV C,D";
    OpCode[75] = "MOV C,E";
    OpCode[76] = "MOV C,H";
    OpCode[77] = "MOV C,L";
    OpCode[78] = "MOV C,M";
    OpCode[79] = "MOV C,A";
    OpCode[80] = "MOV D,B";
    OpCode[81] = "MOV D,C";
    OpCode[82] = "MOV D,D";
    OpCode[83] = "MOV D,E";
    OpCode[84] = "MOV D,H";
    OpCode[85] = "MOV D,L";
    OpCode[86] = "MOV D,M";
    OpCode[87] = "MOV D,A";
    OpCode[88] = "MOV E,B";
    OpCode[89] = "MOV E,C";
    OpCode[90] = "MOV E,D";
    OpCode[91] = "MOV E,E";
    OpCode[92] = "MOV E,H";
    OpCode[93] = "MOV E,L";
    OpCode[94] = "MOV E,M";
    OpCode[95] = "MOV E,A";
    OpCode[96] = "MOV H,B";
    OpCode[97] = "MOV H,C";
    OpCode[98] = "MOV H,D";
    OpCode[99] = "MOV H,E";
    OpCode[100] = "MOV H,H";
    OpCode[101] = "MOV H,L";
    OpCode[102] = "MOV H,M";
    OpCode[103] = "MOV H,A";
    OpCode[104] = "MOV L,B";
    OpCode[105] = "MOV L,C";
    OpCode[106] = "MOV L,D";
    OpCode[107] = "MOV L,E";
    OpCode[108] = "MOV L,H";
    OpCode[109] = "MOV L,L";
    OpCode[110] = "MOV L,M";
    OpCode[111] = "MOV L,A";
    OpCode[112] = "MOV M,B";
    OpCode[113] = "MOV M,C";
    OpCode[114] = "MOV M,D";
    OpCode[115] = "MOV M,E";
    OpCode[116] = "MOV M,H";
    OpCode[117] = "MOV M,L";
    OpCode[118] = "HLT";
    OpCode[119] = "MOV M,A";
    OpCode[120] = "MOV A,B";
    OpCode[121] = "MOV A,C";
    OpCode[122] = "MOV A,D";
    OpCode[123] = "MOV A,E";
    OpCode[124] = "MOV A,H";
    OpCode[125] = "MOV A,L";
    OpCode[126] = "MOV A,M";
    OpCode[127] = "MOV A,A";
    OpCode[128] = "ADD B";
    OpCode[129] = "ADD C";
    OpCode[130] = "ADD D";
    OpCode[131] = "ADD E";
    OpCode[132] = "ADD H";
    OpCode[133] = "ADD L";
    OpCode[134] = "ADD M";
    OpCode[135] = "ADD A";
    OpCode[136] = "ADC B";
    OpCode[137] = "ADC C";
    OpCode[138] = "ADC D";
    OpCode[139] = "ADC E";
    OpCode[140] = "ADC H";
    OpCode[141] = "ADC L";
    OpCode[142] = "ADC M";
    OpCode[143] = "ADC A";
    OpCode[144] = "SUB B";
    OpCode[145] = "SUB C";
    OpCode[146] = "SUB D";
    OpCode[147] = "SUB E";
    OpCode[148] = "SUB H";
    OpCode[149] = "SUB L";
    OpCode[150] = "SUB M";
    OpCode[151] = "SUB A";
    OpCode[152] = "SBB B";
    OpCode[153] = "SBB C";
    OpCode[154] = "SBB D";
    OpCode[155] = "SBB E";
    OpCode[156] = "SBB H";
    OpCode[157] = "SBB L";
    OpCode[158] = "SBB M";
    OpCode[159] = "SBB A";
    OpCode[160] = "ANA B";
    OpCode[161] = "ANA C";
    OpCode[162] = "ANA D";
    OpCode[163] = "ANA E";
    OpCode[164] = "ANA H";
    OpCode[165] = "ANA L";
    OpCode[166] = "ANA M";
    OpCode[167] = "ANA A";
    OpCode[168] = "XRA B";
    OpCode[169] = "XRA C";
    OpCode[170] = "XRA D";
    OpCode[171] = "XRA E";
    OpCode[172] = "XRA H";
    OpCode[173] = "XRA L";
    OpCode[174] = "XRA M";
    OpCode[175] = "XRA A";
    OpCode[176] = "ORA B";
    OpCode[177] = "ORA C";
    OpCode[178] = "ORA D";
    OpCode[179] = "ORA E";
    OpCode[180] = "ORA H";
    OpCode[181] = "ORA L";
    OpCode[182] = "ORA M";
    OpCode[183] = "ORA A";
    OpCode[184] = "CMP B";
    OpCode[185] = "CMP C";
    OpCode[186] = "CMP D";
    OpCode[187] = "CMP E";
    OpCode[188] = "CMP H";
    OpCode[189] = "CMP L";
    OpCode[190] = "CMP M";
    OpCode[191] = "CMP A";
    OpCode[192] = "RNZ";
    OpCode[193] = "POP B";
    OpCode[194] = "JNZ";
    OpCode[195] = "JMP";
    OpCode[196] = "CNZ";
    OpCode[197] = "PUSH B";
    OpCode[198] = "ADI";
    OpCode[199] = "RST 0";
    OpCode[200] = "RZ";
    OpCode[201] = "RET";
    OpCode[202] = "JZ";
    OpCode[204] = "CZ";
    OpCode[205] = "CALL";
    OpCode[206] = "ACI";
    OpCode[207] = "RST 1";
    OpCode[208] = "RNC";
    OpCode[209] = "POP D";
    OpCode[210] = "JNC";
    OpCode[211] = "OUT";
    OpCode[212] = "CNC";
    OpCode[213] = "PUSH D";
    OpCode[214] = "SUI";
    OpCode[215] = "RST 2";
    OpCode[216] = "RC";
    OpCode[218] = "JC";
    OpCode[219] = "IN";
    OpCode[220] = "CC";
    OpCode[222] = "SBI";
    OpCode[223] = "RST 3";
    OpCode[224] = "RPO";
    OpCode[225] = "POP H";
    OpCode[226] = "JPO";
    OpCode[227] = "XTHL";
    OpCode[228] = "CPO";
    OpCode[229] = "PUSH H";
    OpCode[230] = "ANI";
    OpCode[231] = "RST 4";
    OpCode[232] = "RPE";
    OpCode[233] = "PCHL";
    OpCode[234] = "JPE";
    OpCode[235] = "XCHG";
    OpCode[236] = "CPE";
    OpCode[238] = "XRI";
    OpCode[239] = "RST 5";
    OpCode[240] = "RP";
    OpCode[241] = "POP PSW";
    OpCode[242] = "JP";
    OpCode[243] = "DI";
    OpCode[244] = "CP";
    OpCode[245] = "PUSH PSW";
    OpCode[246] = "ORI";
    OpCode[247] = "RST 6";
    OpCode[248] = "RM";
    OpCode[249] = "SPHL";
    OpCode[250] = "JM";
    OpCode[251] = "EI";
    OpCode[252] = "CM";
    OpCode[254] = "CPI";
    OpCode[255] = "RST 7";

    InstCode["NOP"] = 0;
    InstCode["LXI B"] = 1;
    InstCode["STAX"] = 2;
    InstCode["INX B"] = 3;
    InstCode["INR B"] = 4;
    InstCode["DCR B"] = 5;
    InstCode["MVI B"] = 6;
    InstCode["RLC"] = 7;
    InstCode["DAD B"] = 9;
    InstCode["LDAX B"] = 10;
    InstCode["DCX B"] = 11;
    InstCode["INR C"] = 12;
    InstCode["DCR C"] = 13;
    InstCode["MVI C"] = 14;
    InstCode["RRC"] = 15;
    InstCode["LXI D"] = 17;
    InstCode["STAX D"] = 18;
    InstCode["INX D"] = 19;
    InstCode["INR D"] = 20;
    InstCode["DCR D"] = 21;
    InstCode["MVI D"] = 22;
    InstCode["RAL"] = 23;
    InstCode["DAD D"] = 25;
    InstCode["LDAX D"] = 26;
    InstCode["DCX D"] = 27;
    InstCode["INR E"] = 28;
    InstCode["DCR E"] = 29;
    InstCode["MVI E"] = 30;
    InstCode["RAR"] = 31;
    InstCode["RIM"] = 32;
    InstCode["LXI H"] = 33;
    InstCode["SHLD"] = 34;
    InstCode["INX H"] = 35;
    InstCode["INR H"] = 36;
    InstCode["DCR H"] = 37;
    InstCode["MVI H"] = 38;
    InstCode["DAA"] = 39;
    InstCode["DAD H"] = 41;
    InstCode["LHLD"] = 42;
    InstCode["DCX H"] = 43;
    InstCode["INR L"] = 44;
    InstCode["DCR L"] = 45;
    InstCode["MVI L"] = 46;
    InstCode["CMA"] = 47;
    InstCode["SIM"] = 48;
    InstCode["LXI SP"] = 49;
    InstCode["STA"] = 50;
    InstCode["INX SP"] = 51;
    InstCode["INR M"] = 52;
    InstCode["DCR M"] = 53;
    InstCode["MVI M"] = 54;
    InstCode["STC"] = 55;
    InstCode["DAD SP"] = 57;
    InstCode["LDA"] = 58;
    InstCode["DCX SP"] = 59;
    InstCode["INR A"] = 60;
    InstCode["DCR A"] = 61;
    InstCode["MVI A"] = 62;
    InstCode["CMC"] = 63;
    InstCode["MOV B,B"] = 64;
    InstCode["MOV B,C"] = 65;
    InstCode["MOV B,D"] = 66;
    InstCode["MOV B,E"] = 67;
    InstCode["MOV B,H"] = 68;
    InstCode["MOV B,L"] = 69;
    InstCode["MOV B,M"] = 70;
    InstCode["MOV B,A"] = 71;
    InstCode["MOV C,B"] = 72;
    InstCode["MOV C,C"] = 73;
    InstCode["MOV C,D"] = 74;
    InstCode["MOV C,E"] = 75;
    InstCode["MOV C,H"] = 76;
    InstCode["MOV C,L"] = 77;
    InstCode["MOV C,M"] = 78;
    InstCode["MOV C,A"] = 79;
    InstCode["MOV D,B"] = 80;
    InstCode["MOV D,C"] = 81;
    InstCode["MOV D,D"] = 82;
    InstCode["MOV D,E"] = 83;
    InstCode["MOV D,H"] = 84;
    InstCode["MOV D,L"] = 85;
    InstCode["MOV D,M"] = 86;
    InstCode["MOV D,A"] = 87;
    InstCode["MOV E,B"] = 88;
    InstCode["MOV E,C"] = 89;
    InstCode["MOV E,D"] = 90;
    InstCode["MOV E,E"] = 91;
    InstCode["MOV E,H"] = 92;
    InstCode["MOV E,L"] = 93;
    InstCode["MOV E,M"] = 94;
    InstCode["MOV E,A"] = 95;
    InstCode["MOV H,B"] = 96;
    InstCode["MOV H,C"] = 97;
    InstCode["MOV H,D"] = 98;
    InstCode["MOV H,E"] = 99;
    InstCode["MOV H,H"] = 100;
    InstCode["MOV H,L"] = 101;
    InstCode["MOV H,M"] = 102;
    InstCode["MOV H,A"] = 103;
    InstCode["MOV L,B"] = 104;
    InstCode["MOV L,C"] = 105;
    InstCode["MOV L,D"] = 106;
    InstCode["MOV L,E"] = 107;
    InstCode["MOV L,H"] = 108;
    InstCode["MOV L,L"] = 109;
    InstCode["MOV L,M"] = 110;
    InstCode["MOV L,A"] = 111;
    InstCode["MOV M,B"] = 112;
    InstCode["MOV M,C"] = 113;
    InstCode["MOV M,D"] = 114;
    InstCode["MOV M,E"] = 115;
    InstCode["MOV M,H"] = 116;
    InstCode["MOV M,L"] = 117;
    InstCode["HLT"] = 118;
    InstCode["MOV M,A"] = 119;
    InstCode["MOV A,B"] = 120;
    InstCode["MOV A,C"] = 121;
    InstCode["MOV A,D"] = 122;
    InstCode["MOV A,E"] = 123;
    InstCode["MOV A,H"] = 124;
    InstCode["MOV A,L"] = 125;
    InstCode["MOV A,M"] = 126;
    InstCode["MOV A,A"] = 127;
    InstCode["ADD B"] = 128;
    InstCode["ADD C"] = 129;
    InstCode["ADD D"] = 130;
    InstCode["ADD E"] = 131;
    InstCode["ADD H"] = 132;
    InstCode["ADD L"] = 133;
    InstCode["ADD M"] = 134;
    InstCode["ADD A"] = 135;
    InstCode["ADC B"] = 136;
    InstCode["ADC C"] = 137;
    InstCode["ADC D"] = 138;
    InstCode["ADC E"] = 139;
    InstCode["ADC H"] = 140;
    InstCode["ADC L"] = 141;
    InstCode["ADC M"] = 142;
    InstCode["ADC A"] = 143;
    InstCode["SUB B"] = 144;
    InstCode["SUB C"] = 145;
    InstCode["SUB D"] = 146;
    InstCode["SUB E"] = 147;
    InstCode["SUB H"] = 148;
    InstCode["SUB L"] = 149;
    InstCode["SUB M"] = 150;
    InstCode["SUB A"] = 151;
    InstCode["SBB B"] = 152;
    InstCode["SBB C"] = 153;
    InstCode["SBB D"] = 154;
    InstCode["SBB E"] = 155;
    InstCode["SBB H"] = 156;
    InstCode["SBB L"] = 157;
    InstCode["SBB M"] = 158;
    InstCode["SBB A"] = 159;
    InstCode["ANA B"] = 160;
    InstCode["ANA C"] = 161;
    InstCode["ANA D"] = 162;
    InstCode["ANA E"] = 163;
    InstCode["ANA H"] = 164;
    InstCode["ANA L"] = 165;
    InstCode["ANA M"] = 166;
    InstCode["ANA A"] = 167;
    InstCode["XRA B"] = 168;
    InstCode["XRA C"] = 169;
    InstCode["XRA D"] = 170;
    InstCode["XRA E"] = 171;
    InstCode["XRA H"] = 172;
    InstCode["XRA L"] = 173;
    InstCode["XRA M"] = 174;
    InstCode["XRA A"] = 175;
    InstCode["ORA B"] = 176;
    InstCode["ORA C"] = 177;
    InstCode["ORA D"] = 178;
    InstCode["ORA E"] = 179;
    InstCode["ORA H"] = 180;
    InstCode["ORA L"] = 181;
    InstCode["ORA M"] = 182;
    InstCode["ORA A"] = 183;
    InstCode["CMP B"] = 184;
    InstCode["CMP C"] = 185;
    InstCode["CMP D"] = 186;
    InstCode["CMP E"] = 187;
    InstCode["CMP H"] = 188;
    InstCode["CMP L"] = 189;
    InstCode["CMP M"] = 190;
    InstCode["CMP A"] = 191;
    InstCode["RNZ"] = 192;
    InstCode["POP B"] = 193;
    InstCode["JNZ"] = 194;
    InstCode["JMP"] = 195;
    InstCode["CNZ"] = 196;
    InstCode["PUSH B"] = 197;
    InstCode["ADI"] = 198;
    InstCode["RST 0"] = 199;
    InstCode["RZ"] = 200;
    InstCode["RET"] = 201;
    InstCode["JZ"] = 202;
    InstCode["CZ"] = 204;
    InstCode["CALL"] = 205;
    InstCode["ACI"] = 206;
    InstCode["RST 1"] = 207;
    InstCode["RNC"] = 208;
    InstCode["POP D"] = 209;
    InstCode["JNC"] = 210;
    InstCode["OUT"] = 211;
    InstCode["CNC"] = 212;
    InstCode["PUSH D"] = 213;
    InstCode["SUI"] = 214;
    InstCode["RST 2"] = 215;
    InstCode["RC"] = 216;
    InstCode["JC"] = 218;
    InstCode["IN"] = 219;
    InstCode["CC"] = 220;
    InstCode["SBI"] = 222;
    InstCode["RST 3"] = 223;
    InstCode["RPO"] = 224;
    InstCode["POP H"] = 225;
    InstCode["JPO"] = 226;
    InstCode["XTHL"] = 227;
    InstCode["CPO"] = 228;
    InstCode["PUSH H"] = 229;
    InstCode["ANI"] = 230;
    InstCode["RST 4"] = 231;
    InstCode["RPE"] = 232;
    InstCode["PCHL"] = 233;
    InstCode["JPE"] = 234;
    InstCode["XCHG"] = 235;
    InstCode["CPE"] = 236;
    InstCode["XRI"] = 238;
    InstCode["RST 5"] = 239;
    InstCode["RP"] = 240;
    InstCode["POP PSW"] = 241;
    InstCode["JP"] = 242;
    InstCode["DI"] = 243;
    InstCode["CP"] = 244;
    InstCode["PUSH PSW"] = 245;
    InstCode["ORI"] = 246;
    InstCode["RST 6"] = 247;
    InstCode["RM"] = 248;
    InstCode["SPHL"] = 249;
    InstCode["JM"] = 250;
    InstCode["EI"] = 251;
    InstCode["CM"] = 252;
    InstCode["CPI"] = 254;
}
