#include <mainwin.h>

/********************** CONTRIBUTED BY SASWAT PADHI *************************
*****************************************************************************/    
void MainWin::UpdateFromF()
{
    std::string FBin = "00000000";
    int K = 7;
    int FVal = Register[IndexOfRegister["F"]];
    while(FVal)
    {
        if(FVal%2)
            FBin[K] = '1';
        FVal /= 2;
        K--;
    }

    Flag[IndexOfFlag["S"]] = FBin[0] - '0';
    Flag[IndexOfFlag["Z"]] = FBin[1] - '0';
    Flag[IndexOfFlag["P"]] = FBin[5] - '0';
    Flag[IndexOfFlag["AC"]] = FBin[3] - '0';
    Flag[IndexOfFlag["CY"]] = FBin[7] - '0';
}

void MainWin::UpdateF()
{
    std::string FBin = "00000000";
    FBin[0] = Flag[IndexOfFlag["S"]] + '0';
    FBin[1] = Flag[IndexOfFlag["Z"]] + '0';
    FBin[3] = Flag[IndexOfFlag["AC"]] + '0';
    FBin[5] = Flag[IndexOfFlag["P"]] + '0';
    FBin[7] = Flag[IndexOfFlag["CY"]] + '0';

    int K = 7, Pow2 = 1;
    int FVal = 0;
    while(K > -1)
    {
        if(FBin[K]-'0')
            FVal += Pow2;
        Pow2 <<= 1;
        K--;
    }
    
    Register[IndexOfRegister["F"]] = FVal;
}

void MainWin::UpdateAF()
{
    char Total[5];
    UpdateF();
    sprintf(Total,"%02X%02X",Register[IndexOfRegister["A"]],Register[IndexOfRegister["F"]]);
    sscanf(Total, "%X", &Register[IndexOfRegister["PSW"]]);
}

void MainWin::UpdateA_F()
{
    char Total[5];
    sprintf(Total,"%04X",Register[IndexOfRegister["PSW"]]);
    sscanf(Total, "%2X%2X", &Register[IndexOfRegister["A"]], &Register[IndexOfRegister["F"]]);
    UpdateFromF();
}

void MainWin::UpdateBC()
{
    char Total[5];
    sprintf(Total,"%02X%02X",Register[IndexOfRegister["B"]],Register[IndexOfRegister["C"]]);
    sscanf(Total, "%X", &Register[IndexOfRegister["BC"]]);
}

void MainWin::UpdateB_C()
{
    char Total[5];
    sprintf(Total,"%04X",Register[IndexOfRegister["BC"]]);
    sscanf(Total, "%2X%2X", &Register[IndexOfRegister["B"]], &Register[IndexOfRegister["C"]]);
}

void MainWin::UpdateDE()
{
    char Total[5];
    sprintf(Total,"%02X%02X",Register[IndexOfRegister["D"]],Register[IndexOfRegister["E"]]);
    sscanf(Total, "%X", &Register[IndexOfRegister["DE"]]);
}

void MainWin::UpdateD_E()
{
    char Total[5];
    sprintf(Total,"%04X",Register[IndexOfRegister["DE"]]);
    sscanf(Total, "%2X%2X", &Register[IndexOfRegister["D"]], &Register[IndexOfRegister["E"]]);
}

void MainWin::UpdateHL()
{
    char Total[5];
    sprintf(Total,"%02X%02X",Register[IndexOfRegister["H"]],Register[IndexOfRegister["L"]]);
    sscanf(Total, "%X", &Register[IndexOfRegister["HL"]]);
}

void MainWin::UpdateH_L()
{
    char Total[5];
    sprintf(Total,"%04X",Register[IndexOfRegister["HL"]]);
    sscanf(Total, "%2X%2X", &Register[IndexOfRegister["H"]], &Register[IndexOfRegister["L"]]);
}

void MainWin::SetParity(int X)
{
    int J = 1;
    while(X)
    {
        if(X % 2)
            J = (1 - J);
        X /= 2;
    }
    Flag[IndexOfFlag["P"]] = J;

    if(Flag[IndexOfFlag["P"]] != OFlag[IndexOfFlag["P"]])
    {
        ChangedFlags.push_back("P");
        OFlag[IndexOfFlag["P"]] = Flag[IndexOfFlag["P"]];
    }
}

void MainWin::NormalizeRegister(std::string Reg)
{
    int MAX_SIZE;
        
    if(Reg.size() < 2)
        MAX_SIZE = Limit[Reg];
    else
        MAX_SIZE = Limit[Reg];

    if(Register[IndexOfRegister[Reg]] < 0)
        Register[IndexOfRegister[Reg]] += (MAX_SIZE+1);
    else if(Register[IndexOfRegister[Reg]] > MAX_SIZE)
        Register[IndexOfRegister[Reg]] %= (MAX_SIZE+1);
}

void MainWin::NormalizeMemory(int Address)
{
    if(Memory[Address] < 0)
        Memory[Address] += 255;
    else if(Memory[Address] > 255)
        Memory[Address] %= 255;
}

void MainWin::UpdateFlags(int Address)
{
    int MAX_SIZE = 255;
    
    if(Memory[Address])
        Flag[IndexOfFlag["Z"]] = 0;
    else
        Flag[IndexOfFlag["Z"]] = 1;
    if(Memory[Address] > MAX_SIZE)
        Flag[IndexOfFlag["CY"]] = 1;
    else
        Flag[IndexOfFlag["CY"]] = 0;
    if(Memory[Address] < 0)
        Flag[IndexOfFlag["S"]] = 1;
    else
        Flag[IndexOfFlag["S"]] = 0;

    if(Flag[IndexOfFlag["Z"]] != OFlag[IndexOfFlag["Z"]])
    {
        ChangedFlags.push_back("Z");
        OFlag[IndexOfFlag["Z"]] = Flag[IndexOfFlag["Z"]];
    }

    if(Flag[IndexOfFlag["CY"]] != OFlag[IndexOfFlag["CY"]])
    {
        ChangedFlags.push_back("CY");
        OFlag[IndexOfFlag["CY"]] = Flag[IndexOfFlag["CY"]];
    }

    if(Flag[IndexOfFlag["S"]] != OFlag[IndexOfFlag["S"]])
    {
        ChangedFlags.push_back("S");
        OFlag[IndexOfFlag["S"]] = Flag[IndexOfFlag["S"]];
    }

    SetParity(Memory[Address]);
    UpdateAF();
    NormalizeMemory(Address);
}

void MainWin::UpdateFlags(std::string Result)
{
    int MAX_SIZE = Limit[Result];
    
    if(Register[IndexOfRegister[Result]])
        Flag[IndexOfFlag["Z"]] = 0;
    else
        Flag[IndexOfFlag["Z"]] = 1;

    if(Register[IndexOfRegister[Result]] > MAX_SIZE)
        Flag[IndexOfFlag["CY"]] = 1;
    else
        Flag[IndexOfFlag["CY"]] = 0;

    if(Register[IndexOfRegister[Result]] < 0)
        Flag[IndexOfFlag["S"]] = 1;
    else
        Flag[IndexOfFlag["S"]] = 0;

    if(Flag[IndexOfFlag["Z"]] != OFlag[IndexOfFlag["Z"]])
    {
        ChangedFlags.push_back("Z");
        OFlag[IndexOfFlag["Z"]] = Flag[IndexOfFlag["Z"]];
    }

    if(Flag[IndexOfFlag["CY"]] != OFlag[IndexOfFlag["CY"]])
    {
        ChangedFlags.push_back("CY");
        OFlag[IndexOfFlag["CY"]] = Flag[IndexOfFlag["CY"]];
    }

    if(Flag[IndexOfFlag["S"]] != OFlag[IndexOfFlag["S"]])
    {
        ChangedFlags.push_back("S");
        OFlag[IndexOfFlag["S"]] = Flag[IndexOfFlag["S"]];
    }

    SetParity(Register[IndexOfRegister[Result]]);
    UpdateAF();
    NormalizeRegister(Result);
}
